-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassScriptModule.chs

-- 

module HGamer3D.Bindings.CEGUI.ClassScriptModule where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.CEGUI.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}
import HGamer3D.Bindings.CEGUI.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}
import HGamer3D.Bindings.CEGUI.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}

-- | Destructor for ScriptModule
delete :: HG3DClass  -- ^ classpointer - pointer of Class instance which is going to be deleted.
  ->  IO ()
 -- ^ 
delete a1 =
  withHG3DClass a1 $ \a1' -> 
  delete'_ a1' >>= \res ->
  return ()
{-# LINE 47 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}

-- | Execute a script file. 
executeScriptFile :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ filename - String object holding the filename of the script file that is to be executed
  ->  String  -- ^ resourceGroup - Resource group idendifier to be passed to the ResourceProvider when loading the script file. 
  ->  IO ()
 -- ^ 
executeScriptFile a1 a2 a3 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  withCString a3 $ \a3' -> 
  executeScriptFile'_ a1' a2' a3' >>= \res ->
  return ()
{-# LINE 53 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}

-- | Execute a scripted global function. The function should not take any parameters and should return an integer. 
executeScriptGlobal :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ function_name - String object holding the name of the function, in the global script environment, that is to be executed.
  ->  IO (Int)
 -- ^ return value - The integer value returned from the script function.     
executeScriptGlobal a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  executeScriptGlobal'_ a1' a2' a3' >>= \res ->
  peekIntConv  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 59 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}

-- | Execute a scripted global 'event handler' function. The function should take some kind of EventArgsEventArgs
executeScriptedEventHandler :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ handler_name - String object holding the name of the scripted handler function.
  ->  HG3DClass  -- ^ e - EventArgs based object that should be passed, by any appropriate means, to the scripted function.
  ->  IO (Bool)
 -- ^ 
executeScriptedEventHandler a1 a2 a3 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  withHG3DClass a3 $ \a3' -> 
  alloca $ \a4' -> 
  executeScriptedEventHandler'_ a1' a2' a3' a4' >>= \res ->
  peekBoolUtil  a4'>>= \a4'' -> 
  return (a4'')
{-# LINE 66 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}

-- | Execute script code contained in the given CEGUI::String object. 
executeString :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ str - String object holding the valid script code that should be executed.
  ->  IO ()
 -- ^ return value - Nothing.     
executeString a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  executeString'_ a1' a2' >>= \res ->
  return ()
{-# LINE 71 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}

-- | Method called during system initialisation, prior to running any scripts via the ScriptModuleScriptModule
createBindings :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ return value - Nothing.     
createBindings a1 =
  withHG3DClass a1 $ \a1' -> 
  createBindings'_ a1' >>= \res ->
  return ()
{-# LINE 75 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}

-- | Method called during system destruction, after all scripts have been run via the ScriptModuleScriptModule
destroyBindings :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ return value - Nothing.     
destroyBindings a1 =
  withHG3DClass a1 $ \a1' -> 
  destroyBindings'_ a1' >>= \res ->
  return ()
{-# LINE 79 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}

-- | Return identification string for the ScriptModuleScriptModule
getIdentifierString :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (String)
 -- ^ return value - String object holding a string that identifies the     
getIdentifierString a1 =
  withHG3DClass a1 $ \a1' -> 
  alloc64k $ \a2' -> 
  getIdentifierString'_ a1' a2' >>= \res ->
  peekCString  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 84 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}

-- | Sets the default resource group to be used when loading script files. 
setDefaultResourceGroup :: String  -- ^ resourceGroup - String describing the default resource group identifier to be used.
  ->  IO ()
 -- ^ return value - Nothing.     
setDefaultResourceGroup a1 =
  withCString a1 $ \a1' -> 
  setDefaultResourceGroup'_ a1' >>= \res ->
  return ()
{-# LINE 88 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}

-- | Returns the default resource group used when loading script files. 
getDefaultResourceGroup :: IO (String)
 -- ^ return value - String describing the default resource group identifier..     
getDefaultResourceGroup =
  alloc64k $ \a1' -> 
  getDefaultResourceGroup'_ a1' >>= \res ->
  peekCString  a1'>>= \a1'' -> 
  return (a1'')
{-# LINE 92 ".\\HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs.h cegui_scrmd_destruct"
  delete'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs.h cegui_scrmd_executeScriptFile"
  executeScriptFile'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CChar) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs.h cegui_scrmd_executeScriptGlobal"
  executeScriptGlobal'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CInt) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs.h cegui_scrmd_executeScriptedEventHandler"
  executeScriptedEventHandler'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs.h cegui_scrmd_executeString"
  executeString'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs.h cegui_scrmd_createBindings"
  createBindings'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs.h cegui_scrmd_destroyBindings"
  destroyBindings'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs.h cegui_scrmd_getIdentifierString"
  getIdentifierString'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs.h cegui_scrmd_setDefaultResourceGroup"
  setDefaultResourceGroup'_ :: ((Ptr CChar) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassScriptModule.chs.h cegui_scrmd_getDefaultResourceGroup"
  getDefaultResourceGroup'_ :: ((Ptr CChar) -> (IO ()))
